#include <iostream>

using namespace std;

int ai,aj,bi,bj;
bool check(int a[2000][2000],int n,int k)
{


}
int main()
{
    int n,k,br=0;
    cin>>n>>k;
    int a[n+1][n+1]={0};
    for(int i=0;i<n;i++)
        for(int j=0;j<n;j++)
            cin>>a[i][j];
    int b[k]={0};
    bool x;
    for(int i=1;i<=k;i++)
    {
        ai=aj=bi=bj=-1;
        bool x=true;
        for(int i=0;i<n;i++)
        {
            for(int j=0;j<n;j++)
            {
                if(a[i][j]==k && x==true)
                {
                    x=false;
                    ai=i;
                    aj=j;
                }
                bi=i;
                bj=j;
            }
        }
        if(ai==-1)
        {
            b[i-1]=2;
            continue;
        }
        for(int i=ai;i<bi;i++)
            for(int j=aj;j<bj;j++)
                if(a[i][j]==k)
                    a[i][j]=0;
                else
                    x=false;
        if(x)
            b[i-1]=1;
        else
            b[i-1]=2;
        x=true;
    }
    for(int i=0;i<n;i++)
        for(int j=0;j<n;j++)
        {
            if(a[i][j]!=0)
                b[a[i][j]+1]=2;
        }
    for(int i=0;i<k;i++)
        if(b[i]==1)
            br++;
    cout<<br;
    return 0;
}